Project Chrono: chrono::vehicle::hmmwv::HMMWV_Driveline4WD Class Reference

Public Member Functions | List of all members
chrono::vehicle::hmmwv::HMMWV_Driveline4WD Class Reference
Models » Vehicle models » HMMWV

## Description

Shafts-based 4-WD driveline for the HMMWV vehicle.

`#include <HMMWV_Driveline4WD.h>`

Inheritance diagram for chrono::vehicle::hmmwv::HMMWV_Driveline4WD:
[legend]
Collaboration diagram for chrono::vehicle::hmmwv::HMMWV_Driveline4WD:
[legend]

## Public Member Functions
| HMMWV_Driveline4WD (const std::string &name)
virtual double | GetCentralDifferentialBoxInertia () const override
| Return the inertia of the differential box.
virtual double | GetFrontDifferentialBoxInertia () const override
| Return the inertia of the front differential box.
virtual double | GetRearDifferentialBoxInertia () const override
| Return the inertia of the rear differential box.
virtual double | GetDriveshaftInertia () const override
| Return the inertia of the driveshaft.
virtual double | GetToFrontDiffShaftInertia () const override
| Return the inertia of the front driveshaft.
virtual double | GetToRearDiffShaftInertia () const override
| Return the inertia of the rear driveshaft.
virtual double | GetFrontConicalGearRatio () const override
| Return the gear ratio for the front conical gear.
virtual double | GetRearConicalGearRatio () const override
| Return the gear ratio for the rear conical gear.
virtual double | GetAxleDifferentialLockingLimit () const override
| Return the limit for the axle differential locking torque.
virtual double | GetCentralDifferentialLockingLimit () const override
| Return the limit for the central differential locking torque.
Public Member Functions inherited from chrono::vehicle::ChShaftsDriveline4WD
| ChShaftsDriveline4WD (const std::string &name)
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
void | SetMotorBlockDirection (const ChVector3d &dir)
| Set the direction of the motor block.
void | SetAxleDirection (const ChVector3d &dir)
| Set the direction of the wheel axles.
virtual void | LockAxleDifferential (int axle, bool lock) override
| Lock/unlock the differential on the specified axle.
virtual void | LockCentralDifferential (int which, bool lock) override
| Lock/unlock the central differential.
virtual unsigned int | GetNumDrivenAxles () const final override
| Return the number of driven axles.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, const ChAxleList &axles, const std::vector< int > &driven_axles) override
| Initialize the driveline subsystem.
virtual void | Synchronize (double time, const DriverInputs &driver_inputs, double driveshaft_torque) override
| Update the driveline subsystem.
virtual double | GetSpindleTorque (int axle, VehicleSide side) const override
| Get the motor torque to be applied to the specified spindle.
virtual void | Disconnect () override
| Disconnect driveline from driven wheels.
virtual double | GetOutputDriveshaftSpeed () const override
| Return the output driveline speed of the driveshaft.
Public Member Functions inherited from chrono::vehicle::ChDrivelineWV
const std::vector< int > & | GetDrivenAxleIndexes () const
| Get the indexes of the vehicle's axles driven by this driveline subsystem.
Public Member Functions inherited from chrono::vehicle::ChDriveline
void | Initialize (std::shared_ptr< ChChassis > chassis)
| Initialize the driveline.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis)
| Add visualization assets to this subsystem, for the specified visualization mode.
virtual void | RemoveVisualizationAssets ()
| Remove all visualization assets from this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const
| Output data for this subsystem's component list to the specified database.

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Protected Member Functions inherited from chrono::vehicle::ChDrivelineWV
| ChDrivelineWV (const std::string &name)
Protected Member Functions inherited from chrono::vehicle::ChDriveline
| ChDriveline (const std::string &name)
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).
Protected Attributes inherited from chrono::vehicle::ChDrivelineWV
std::vector< int > | m_driven_axles
| indexes of the driven vehicle axles
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Member Function Documentation

## ◆ GetAxleDifferentialLockingLimit()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetAxleDifferentialLockingLimit | ( |  | ) | const
| inlineoverridevirtual

Return the limit for the axle differential locking torque.

Implements chrono::vehicle::ChShaftsDriveline4WD.

## ◆ GetCentralDifferentialBoxInertia()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetCentralDifferentialBoxInertia | ( |  | ) | const
| inlineoverridevirtual

Return the inertia of the differential box.

Implements chrono::vehicle::ChShaftsDriveline4WD.

## ◆ GetCentralDifferentialLockingLimit()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetCentralDifferentialLockingLimit | ( |  | ) | const
| inlineoverridevirtual

Return the limit for the central differential locking torque.

Implements chrono::vehicle::ChShaftsDriveline4WD.

## ◆ GetDriveshaftInertia()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetDriveshaftInertia | ( |  | ) | const
| inlineoverridevirtual

Return the inertia of the driveshaft.

Implements chrono::vehicle::ChShaftsDriveline4WD.

## ◆ GetFrontConicalGearRatio()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetFrontConicalGearRatio | ( |  | ) | const
| inlineoverridevirtual

Return the gear ratio for the front conical gear.

Implements chrono::vehicle::ChShaftsDriveline4WD.

## ◆ GetFrontDifferentialBoxInertia()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetFrontDifferentialBoxInertia | ( |  | ) | const
| inlineoverridevirtual

Return the inertia of the front differential box.

Implements chrono::vehicle::ChShaftsDriveline4WD.

## ◆ GetRearConicalGearRatio()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetRearConicalGearRatio | ( |  | ) | const
| inlineoverridevirtual

Return the gear ratio for the rear conical gear.

Implements chrono::vehicle::ChShaftsDriveline4WD.

## ◆ GetRearDifferentialBoxInertia()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetRearDifferentialBoxInertia | ( |  | ) | const
| inlineoverridevirtual

Return the inertia of the rear differential box.

Implements chrono::vehicle::ChShaftsDriveline4WD.

## ◆ GetToFrontDiffShaftInertia()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetToFrontDiffShaftInertia | ( |  | ) | const
| inlineoverridevirtual

Return the inertia of the front driveshaft.

Implements chrono::vehicle::ChShaftsDriveline4WD.

## ◆ GetToRearDiffShaftInertia()

virtual double chrono::vehicle::hmmwv::HMMWV_Driveline4WD::GetToRearDiffShaftInertia | ( |  | ) | const
| inlineoverridevirtual

Return the inertia of the rear driveshaft.

Implements chrono::vehicle::ChShaftsDriveline4WD.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_models/vehicle/hmmwv/driveline/HMMWV_Driveline4WD.h
- D:/W/B/src/chrono-9.0.1/src/chrono_models/vehicle/hmmwv/driveline/HMMWV_Driveline4WD.cpp